unit AddRotator;
{Copyright 2001 John Williams}
{V1.0}
  { TODO  : Add Ftp Support to automaticaly check for and download a new address list. }
interface

uses
  Windows, Messages, SysUtils, Classes, Controls, OleCtrls, SHDocVw,extctrls,stdctrls,nmhttp,registry,dialogs,shellapi;

type
  TRotateType = (RT_Refresh,RT_NextWebItem);

type Tupdatethread = class(tthread)
       UpdateUrl       : string;
       CheckUpdate     : Boolean;
       AddUrl          : string;
       LoadAdds        : Boolean;
       ProgramVersion  : longint;
       ProgramId       : longint;
       parent          : TComponent;
       templist:tstringlist;
       addduration:integer;
       AddRotate:integer;
       httpcomp:Tnmhttp;
       function getaddress(address:string):string;
       function getport(address:string):longint;
       procedure NMHTTP1Failure(Cmd: CmdType);
       procedure NMHTTP1Success(Cmd: CmdType);
       procedure NMHTTP1AuthenticationNeeded(Sender: TObject);
       procedure execute; override;
       function checkforupgrade:boolean;
       Procedure UpdateComponent;
     end;

type
  TAddRotator = class(TWebBrowser)
  private
    FRefreshInterval : integer;
    Factive          : boolean;
    FOnTimer         : TnotifyEvent;
    FOnError         : TnotifyEvent;
    FLines           : tstringlist;
    FWebItem         : integer;
    FRotate          : TRotatetype;
    FCurrentWebItem  : integer;
    FUpdateUrl       : string;
    FCheckUpdate     : Boolean;
    FAddUrl          : string;
    FLoadAdds        : Boolean;
    FProgramVersion  : longint;
    FProgramId       : longint;
    { Private declarations }
  protected
    MyTimer:ttimer;
    intimer:boolean;
    updatethread:tupdatethread;
    procedure setactive(value:boolean);
    procedure DoTimer(Sender: TObject);
    procedure loaded;override;
    procedure SetLines(Value: TStringlist);
    procedure setwebline(value:integer);
    procedure SetRefreshInterval(value:integer);
    { Protected declarations }
  public
    { Public declarations }
    procedure checkupgrade;
  published
    constructor Create(AOwner: TComponent);override;
    property Active : boolean read factive write setactive;
    property RefreshInterval : integer read FRefreshInterval write setRefreshInterval;
    property Lines: TStringlist read FLines write SetLines;
    property WebItem: integer read FWebItem write setwebline;
    property OnTimer: TNotifyEvent read FOnTimer write FOnTimer;
    property OnError: TNotifyEvent read FOnError write FOnError;
    property Rotate : TRotatetype read FRotate write Frotate;
    property UpdateURL : string read FUpdateUrl write FUpdateUrl;
    property CheckUpdate : boolean read FCheckUpdate write FCheckUpdate;
    property AddURL : string read FAddUrl write FAddUrl;
    property LoadAdds : boolean read FLoadAdds write FLoadAdds;
    property ProgramVersion : longint read FProgramVersion write FProgramVersion;
    property ProgramID : longint read FProgramId write FProgramId;

    { Published declarations }
  end;

procedure Register;

implementation

procedure TAddRotator.SetRefreshInterval(value:integer);

begin
  FRefreshInterval:=value;
  if (not (csDesigning in componentstate)) then
  begin
    if FRefreshInterval >0 then
    begin
      Mytimer.OnTimer:=Dotimer;
      Mytimer.Interval:=FRefreshInterval;
      Mytimer.Enabled:=true;
    end
    else
    begin
      Mytimer.Enabled:=false;
      Mytimer.OnTimer:=nil;
    end;
  end;
end;

procedure TAddRotator.SetwebLine(Value: integer);

begin
  if flines.count=0 then
    FWebItem:=-1
  else
    if value>flines.count then
      FWebItem:=flines.count-1
    else
      FWebItem:=value
end;


procedure TAddRotator.SetLines(Value: TStringlist);

begin
  FLines.Assign(Value);
  if flines.count=0 then
    FWebItem:=-1
  else
    if FWebItem=-1 then
      FWebItem:=0;
end;

procedure TAddRotator.loaded;

begin
  if (not (csDesigning in componentstate)) then
  begin
    try
      if checkupdate then
      begin
        checkupgrade;
      end;
      if factive then
      begin
        if Flines.count>0 then
        begin
          case frotate of
            RT_Refresh     : if (FWebItem>-1) and (FWebItem<FLines.count) then
                               Navigate(FLines[FWebItem]);
            RT_NextWebItem : begin
                               FCurrentWebItem:=0;
                               Navigate(FLines[FCurrentWebItem]);
                             end;
          end;

          if FRefreshInterval >0 then
          begin
            Mytimer.OnTimer:=Dotimer;
            Mytimer.Interval:=FRefreshInterval;
            Mytimer.Enabled:=true;
          end;
        end;
      end
      else
      begin
        Mytimer.OnTimer:=nil;
        Mytimer.Enabled:=false;
      end;
    except
      if assigned(FonError) then
        FonError(self);
    end;
  end;
end;

procedure TAddRotator.DoTimer(Sender: TObject);
begin
  if intimer then
    exit;
  intimer:=true;
  try
    case frotate of
      RT_Refresh     : Refresh;
      RT_NextWebItem : begin
                         inc(FCurrentWebItem);
                         if FCurrentWebItem>=Flines.count then
                           FCurrentWebItem:=0;
                         if FCurrentWebItem<Flines.count then
                           Navigate(FLines[FCurrentWebItem]);
                       end;
    end;

    if assigned(FonTimer) then
      FonTimer(sender);
  except
    if assigned(FonError) then
      FonError(self);
  end;
  intimer:=false;
end;

procedure TAddRotator.setactive(value:boolean);

begin
  try
    factive:=value;
    if (not (csDesigning in componentstate)) and
       (not (csloading in componentstate)) then
    begin
      if factive then
      begin
        case frotate of
          RT_Refresh     : if (FWebItem>-1) and (FWebItem<FLines.count) then
                               Navigate(FLines[FWebItem]);
          RT_NextWebItem : begin
                             FCurrentWebItem:=0;
                             Navigate(FLines[FCurrentWebItem]);
                           end;
        end;
        if FRefreshInterval >0 then
        begin
          mytimer.OnTimer:=Dotimer;
          mytimer.Interval:=FRefreshInterval;
          mytimer.Enabled:=true;
        end;
      end
      else
      begin
        mytimer.Enabled:=false;
      end;
    end;
  except
    if assigned(FonError) then
      FonError(self);
  end;
end;

constructor TAddRotator.Create(AOwner: TComponent);

begin
  intimer:=false;
  inherited create(Aowner);
  frotate:=RT_Refresh;
  FLines := TStringlist.Create;
  Flines.Add('http://addrotator.cjb.net/adsample.htm');
  height:=90;
  align:=altop;
  FRefreshInterval:=30000;
  factive:=true;
  FwebItem:=0;
  if (not (csDesigning in componentstate)) then
  begin
    Mytimer:=ttimer.create(self);
  end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TAddRotator]);
end;

function Tupdatethread.checkforupgrade: boolean;

var reg:tregistry;

begin
  httpcomp.OnSuccess:=NMHTTP1Success;
  httpcomp.OnFailure:=NMHTTP1Failure;
  if (UpdateURL<>'') or (AddURL<>'') then
  begin
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_CURRENT_USER;
      if Reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Internet Settings',True) then
      begin
        if reg.ReadInteger('ProxyEnable')<>0 then
        begin
{          httpcomp.Proxy:=getaddress(reg.ReadString('ProxyServer'));
          httpcomp.proxyport:=getport(reg.ReadString('ProxyServer'));}
        end;
      end;
    except
    end;
  end;
  try
  if checkupdate then
    httpcomp.Get(UpdateUrl);
  if loadadds then
    httpcomp.Get(AddUrl);
  except
  end;
end;

function Tupdatethread.getaddress(address: string): string;
begin
  if pos(':',address)<>0 then
    result:=copy(address,1,pos(':',address)-1)
  else
    result:=address;
{}
end;

function Tupdatethread.getport(address: string): longint;
var err:integer;
begin
  if pos(':',address)<>0 then
  begin
    val(copy(address,pos(':',address)+1,length(address)),result,err);
    if err<>0 then
      result:=80;
  end;
{}
end;

procedure Tupdatethread.NMHTTP1AuthenticationNeeded(Sender: TObject);
var
  AnID,
  APass: String;

begin
  InputQuery('Authentication required', 'Enter a user ID', AnID);
  InputQuery('Authentication required', 'Enter a password', APass);
  httpcomp.HeaderInfo.UserId := AnID;
  httpcomp.HeaderInfo.Password := APass;
end;

procedure Tupdatethread.NMHTTP1Failure(Cmd: CmdType);
begin
end;


Procedure Tupdatethread.UpdateComponent;
begin
  TAddRotator(parent).Flines.Assign(templist);
  TAddRotator(parent).FCurrentWebItem:=0;
  TAddRotator(parent).FWebItem:=0;
  TAddRotator(parent).RefreshInterval:=addduration;
  if addrotate=0 then
    TAddRotator(parent).Rotate:=RT_NextWebItem
  else
  begin
    TAddRotator(parent).Rotate:=RT_Refresh;
    if (TAddRotator(parent).FWebItem>-1) and (TAddRotator(parent).FWebItem<TAddRotator(parent).FLines.count) then
      TAddRotator(parent).Navigate(TAddRotator(parent).FLines[TAddRotator(parent).FWebItem]);
  end;
end;

procedure Tupdatethread.NMHTTP1Success(Cmd: CmdType);

var tempstring:string;
    i:longint;
    fromversion:longint;
    toversion:longint;
    progid:longint;
    URL:string;
    err:integer;

begin
  Case Cmd of
    CmdGET:
      begin
        templist:=tstringlist.create;
        templist.Text:=httpcomp.Body;
        if templist.count>0 then
        begin
          if pos('ADDS',trim(uppercase(templist[0])))=1 then
          begin
            tempstring:=trim(copy(templist[0],pos(',',templist[0])+1,length(templist[0])));
            val(copy(tempstring,1,pos(',',tempstring)-1),addduration,err);
            if err<>0 then
              addduration:=60000;
            tempstring:=copy(tempstring,pos(',',tempstring)+1,length(tempstring));
            val(tempstring,addrotate,err);
            if err<>0 then
              addrotate:=0;
            templist.Delete(0);
            synchronize(UpdateComponent);
          end
          else
          begin
            for i:=0 to templist.count-1 do
            begin
              if (trim(templist[i])<>'') and (pos(';',trim(templist[i]))<>1) then
              begin
                tempstring:=trim(templist[i]);
                val(copy(tempstring,1,pos(',',tempstring)-1),progid,err);
                if err=0 then
                begin
                  tempstring:=copy(tempstring,pos(',',tempstring)+1,length(tempstring));
                  val(copy(tempstring,1,pos(',',tempstring)-1),fromversion,err);
                  if err=0 then
                  begin
                    tempstring:=copy(tempstring,pos(',',tempstring)+1,length(tempstring));
                    val(copy(tempstring,1,pos(',',tempstring)-1),toversion,err);
                    if err=0 then
                    begin
                      url:=copy(tempstring,pos(',',tempstring)+1,length(tempstring));
                      if (progid=programid) and (programversion>=fromversion) and (programversion<=toversion) then
                      begin
                        url:=trim(url);
                        shellexecute(0,nil,pchar(url),nil,nil,sw_shownormal);
                      end;
                    end;
                  end;
                end;
              end;
            end;
          end;
        end;
        templist.free;
      end;
  end;
end;

{ Tupdatethread }

procedure Tupdatethread.execute;
begin
  inherited;
  httpcomp:=tnmhttp.Create(nil);
  checkforupgrade;
  httpcomp.free;
end;

procedure TAddRotator.checkupgrade;
begin
  updatethread:=Tupdatethread.create(true);
  updatethread.parent:=self;
  updatethread.UpdateUrl       := FUpdateUrl;
  updatethread.CheckUpdate     := FCheckUpdate;
  updatethread.Loadadds        := FLoadAdds;
  updatethread.addurl          := FAddURL;
  updatethread.ProgramVersion  := FProgramVersion;
  updatethread.ProgramId       := FProgramId;
  updatethread.Resume;
end;

end.
